<template>
  <div class="app-container">
    <el-card>
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="88px">
        <el-form-item label="畜种类型" prop="animalType">
          <el-select v-model="queryParams.animalType">
            <el-option v-for="(item, i) in animalList" :key="i" :value="item.typeValue" :label="item.typeName"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="品种名称" prop="categoryName">
          <el-input
            v-model="queryParams.categoryName"
            placeholder="请输入品种名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>

      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
            v-hasPermi="['app:pigCategory:add']"
          >新增</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            :disabled="multiple"
            @click="handleDelete"
            v-hasPermi="['app:pigCategory:remove']"
          >删除</el-button>
        </el-col>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>

    </el-card>
    <br>
    <el-card>
      <el-table border stripe  v-loading="loading" :data="pigCategoryList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55"  />
        <el-table-column label="畜种类型">
          <template slot-scope="scope">
            <span>{{animalName(scope.row.animalType)}}</span>
          </template>
        </el-table-column>
        <el-table-column label="品种名称"  prop="categoryName" />
        <el-table-column label="默认重量(kg)"  prop="defaultWeight" />
        <el-table-column label="操作" width="180"  class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleView(scope.row)"
            >查看</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['app:pigCategory:edit']"
            >修改</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDelete(scope.row)"
              v-hasPermi="['app:pigCategory:remove']"
            >删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
    </el-card>

    <!-- 添加或修改生猪分类对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" :disabled="isView" label-width="80px">
        <el-form-item label="畜种类型" prop="animalType">
         <el-select v-model="form.animalType">
            <el-option v-for="(item, i) in animalList" :key="i" :value="item.typeValue" :label="item.typeName"></el-option>
         </el-select>
        </el-form-item>
        <el-form-item label="品种名称" prop="categoryName">
          <el-input v-model="form.categoryName" placeholder="请输入品种名称" />
        </el-form-item>
        <el-form-item label="默认重量" prop="defaultWeight">
          <el-input v-model="form.defaultWeight" placeholder="请输入默认重量">
            <template #append>kg</template>
          </el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer" v-if="!isView">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listPigCategory, getPigCategory, delPigCategory, addPigCategory, updatePigCategory } from "@/api/app/pigCategory";
import { rules } from "../../../utils/formRules";
import { mapState } from "vuex";

export default {
  name: "PigCategory",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 生猪分类表格数据
      pigCategoryList: [],
      // 弹出层标题
      title: "",
      isView:false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        animalType: null,
        categoryName: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        animalType: [
          { required: true, message: "畜种类型不能为空", trigger: "change" },
        ],
        categoryName: [
          { required: true, message: "品种名称不能为空", trigger: "blur" },
          { min: 1, max: 10, message: "品种名称输入超出最大长度限制（10位）", trigger: "blur" },
        ],
        defaultWeight: [
          { required: true, message: "默认重量不能为空", trigger: "blur" },
          { pattern: /^(150|1[0-4]\d|[1-9]\d?)$/, message: '正整数，且重量范围（1,150）', trigger: 'blur' }
        ],
      }
    };
  },
  computed: {
    ...mapState({
      animalList: state => state.user.animalList
    }),
    animalName() {
      return (value) => {
        if (value === null) return '未知'
        const animal = this.animalList.find(item =>
          String(item.typeValue) === String(value)
        )
        return animal ? animal.typeName : '未知'
      }
    }
  },
  created() {
    // this.loading = false;
    this.getList();
  },
  methods: {
    /** 查询生猪分类列表 */
    getList() {
      this.loading = true;
      listPigCategory(this.queryParams).then(response => {
        this.pigCategoryList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        animalType: null,
        categoryName: null,
        defaultWeight: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.isView = false;
      this.title = "添加生猪分类";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getPigCategory(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.isView = false;
        this.title = "修改生猪分类";
      });
    },
     /** 查看按钮操作 */
     handleView(row) {
      this.reset();
      const id = row.id || this.ids
      getPigCategory(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.isView = true;
        this.title = "查看生猪分类";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updatePigCategory(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addPigCategory(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除所选数据项？').then(function() {
        return delPigCategory(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('app/pigCategory/export', {
        ...this.queryParams
      }, `pigCategory_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
